drop user test cascade;
create user test identified by test default tablespace users;
grant dba to test;
grant sysdba to test;

connect test/test@T11DB

create table t1 as select rownum as uniqueid, a.* from dba_objects a where rownum < 21;
create unique index t1_i on t1(uniqueid);
exec dbms_stats.gather_table_stats(USER,'T1');

ACCEPT continue CHAR PROMPT 'Reconnect' HIDE
connect sys/manager@T11DB as sysdba
col value format a80
select value from v$diag_info where name = 'Default Trace File';

ACCEPT continue CHAR PROMPT 'Set sql_trace[] event++' HIDE
alter session set events 'sql_trace wait=false,bind=false,plan_stat=never';

ACCEPT continue CHAR PROMPT 'Run SQL with SQL-ID 869cv4hgb868z' HIDE
alter system flush shared_pool;
alter system flush buffer_cache;
select count(*) from test.t1 where uniqueid < 5;

ACCEPT continue CHAR PROMPT 'Reconnect' HIDE
connect sys/manager@T11DB as sysdba
col value format a80
select value from v$diag_info where name = 'Default Trace File';

ACCEPT continue CHAR PROMPT 'Set sql_trace[] event++ for a specific SQL-ID only' HIDE
alter session set events 'sql_trace[SQL: 869cv4hgb868z] wait=false,bind=false,plan_stat=never';

ACCEPT continue CHAR PROMPT 'Run SQL with SQL-ID 869cv4hgb868z' HIDE
alter system flush shared_pool;
alter system flush buffer_cache;
select count(*) from test.t1 where uniqueid < 5;

ACCEPT continue CHAR PROMPT 'Reconnect' HIDE
connect sys/manager@T11DB as sysdba
col value format a80
select value from v$diag_info where name = 'Default Trace File';

ACCEPT continue CHAR PROMPT 'Set sql_trace[] event++ for a specific SQL-ID only including stack traces' HIDE
alter session set events 'sql_trace[SQL: 869cv4hgb868z] wait=false,bind=false,plan_stat=never callstack()';

ACCEPT continue CHAR PROMPT 'Run SQL with SQL-ID 869cv4hgb868z' HIDE
alter system flush shared_pool;
alter system flush buffer_cache;
select count(*) from test.t1 where uniqueid < 5;

ACCEPT continue CHAR PROMPT 'Reconnect' HIDE
connect sys/manager@T11DB as sysdba
col value format a80
select value from v$diag_info where name = 'Default Trace File';

ACCEPT continue CHAR PROMPT 'ORADEBUG DOC EVENT FILTER' HIDE
oradebug doc event filter

ACCEPT continue CHAR PROMPT 'ORADEBUG DOC EVENT FILTER CALLSTACK' HIDE
oradebug doc event filter callstack

ACCEPT continue CHAR PROMPT 'ORADEBUG DOC EVENT FILTER PGADEP' HIDE
oradebug doc event filter pgadep

ACCEPT continue CHAR PROMPT 'ORADEBUG DOC EVENT ACTION crash' HIDE
oradebug doc event action crash

ACCEPT continue CHAR PROMPT 'Set sql_trace[] event++ for a specific SQL-ID only to abort at #FETCH OPI call' HIDE
alter session set events 'sql_trace[SQL: 869cv4hgb868z] {callstack: fname opifch2} {pgadep: exactdepth 0} wait=false,bind=false,plan_stat=never crash()';

ACCEPT continue CHAR PROMPT 'Get execution plan for SQL-ID 869cv4hgb868z' HIDE
alter system flush shared_pool;
alter system flush buffer_cache;
select * from table (DBMS_XPLAN.DISPLAY_CURSOR('869cv4hgb868z',NULL,'ALL ALLSTATS OUTLINE PEEKED_BINDS LAST'));

ACCEPT continue CHAR PROMPT 'Run SQL with SQL-ID 869cv4hgb868z' HIDE
select count(*) from test.t1 where uniqueid < 5;
connect sys/manager@T11DB as sysdba
select * from table (DBMS_XPLAN.DISPLAY_CURSOR('869cv4hgb868z',NULL,'ALL ALLSTATS OUTLINE PEEKED_BINDS LAST'));
