SELECT /*+ no_xml_query_rewrite */
       DISTINCT
       t.parse_id,
       tab.table_owner,
       tab.table_name,
       tab.column_name
  FROM test.txml t,
       XMLTABLE('
                  let $set :=
                     for $i in //queryTableExpression[qteName/@value]
                     let $alias :=
                        if ($i/../tableAlias/alias[@value]) then
                           upper-case($i/../tableAlias/alias/@value)
                        else
                          upper-case($i/qteName/@value)
                     let $qb :=
                        $i/../../../..
                     let $singleColumnExpressions :=
                        for $col in $qb//expression[@xsi:type="plsql:SimpleExpressionNameValue"]
                        return <column tableName="{$i/qteName/@value}" tableSchema="{$i/schema/@value}" columnName="{$col/@value}"/>
                     let $multiColumnExpressions :=
                        for $col in $qb//selected[@xsi:type="plsql:MultiColumnExpression"]
                        where upper-case($col/wildcard/queryable/sqlNames/text()) = $alias
                           or not ($col/wildcard/queryable/sqlNames)
                        return <column tableName="{$i/qteName/@value}" tableSchema="{$i/schema/@value}" columnName="*"/>
                     let $lefts :=
                        for $col in $qb//left[@xsi:type="plsql:SimpleExpressionNameValue" 
                                              and not(../@binaryOperator=".") 
                                              and not (../right/@xsi:type="plsql:ParenthesisExpression")]
                        return <column tableName="{$i/qteName/@value}" tableSchema="{$i/schema/@value}" columnName="{$col/@value}"/>
                     let $rights :=
                        for $col in $qb//right[@xsi:type="plsql:SimpleExpressionNameValue"]
                        where not($col/../@binaryOperator=".")
                           or ($col/../@binaryOperator="." and (upper-case($col/../left/@value) = $alias))
                        return <column tableName="{$i/qteName/@value}" tableSchema="{$i/schema/@value}" columnName="{$col/@value}"/>
                     let $parameterValues :=
                        for $col in $qb//parameterValue[@xsi:type="plsql:SimpleExpressionNameValue"]
                        return <column tableName="{$i/qteName/@value}" tableSchema="{$i/schema/@value}" columnName="{$col/@value}"/>
                     return <set>{$singleColumnExpressions}{$multiColumnExpressions}{$lefts}{$rights}{$parameterValues}</set>
                  for $j in $set//column
                  return <column tableName="{$j/@tableName}" tableSchema="{$j/@tableSchema}" columnName="{$j/@columnName}"/>
                '
                PASSING t.parse_tree
                COLUMNS "TABLE_NAME"     VARCHAR2(30) PATH '@tableName',
                        "TABLE_OWNER"    VARCHAR2(30) PATH '@tableSchema',
                        "COLUMN_NAME"    VARCHAR2(30) PATH '@columnName'
       ) tab
  WHERE t.parse_id = 1;
